#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Sep 19 16:16:54 2022


Solution to Exercise 1a 


@author: richter
"""
import numpy as np
import matplotlib.pyplot as plt
import torch

## [...]

## We create 20 random training points in [0,10]
Ntrain = 20
# It is important that we create the random points with the type
# np.float32
x = np.random.rand(Ntrain,1).astype(np.float32) * 10

## [...] what is y? 


## For PyTorch we must transform the points to a tensor:
xtrain = torch.from_numpy(x)

## [...] you also have to define ytrain, the result for training


## We create the model
model = torch.nn.Sequential(
                torch.nn.Linear(1,5),  # 1 input -> 2
                torch.nn.Sigmoid(),    # sigmoid-activation
                torch.nn.Linear(5,1)   # 2 -> 1
                )                      # no further activation

## We specify the parameters for the optimizer
learningrate, maxiter =0.001,20000
loss_fn = torch.nn.MSELoss(reduction='sum')
optimizer = torch.optim.Adam(model.parameters(),lr=learningrate,weight_decay=0)


for t in range(maxiter+1):   # optimization loop
    torch_prediction = model(xtrain)        # evaluate the model
    loss = loss_fn(torch_prediction,ytrain) # compute the loss
    if t%1000==0:                     # output
        print(t,loss.item(),sep='\t')
    optimizer.zero_grad()                   # 
    loss.backward()                         # compute the gradient
    optimizer.step()                        # one step


## [...]
